<template>
  <button
    class="c88d-btn"
    :class="{ active: isActive }"
    @click="$emit('click')"
  >
    <div class="c88d-btn__container" :with-text="text && text.length > 0">
      <div >
        <div class="c88d-btn__text">
          <p
        >
          {{ text }}
        </p>
        </div>
        
      </div>
    </div>
    <div class="c88d-btn__bottom">
      <div class="c88d-btn__bottom-bar"></div>
    </div>
    <div class="c88d-btn__tag-container">
      <div class="c88d-btn__tags" v-if="enableTags">
        <span class="c88d-btn__tag" v-if="isHot">hot</span>
        <span class="c88d-btn__tag" v-if="isNew">new</span>
      </div>
    </div>
    <slot name="right"></slot>
  </button>
</template>

<script setup lang="ts">
defineEmits(["click"]);
defineProps({
  enableTags: {
    type: Boolean,
    required: false,
    default: () => true,
  },
  isHot: {
    type: Boolean,
    required: false,
    default: () => false,
  },
  isNew: {
    type: Boolean,
    required: false,
    default: () => false,
  },
  logo: {
    type: String,
    required: false,
    default: "",
  },
  text: {
    type: String,
    required: false,
    default: "",
  },
  isActive: {
    type: Boolean,
    required: false,
    default: false,
  },
  isMultipleProvider: {
    type: Boolean,
    required: true,
  },
});
</script>
<style>
:root {
  --c88d-btn-width: 143px;
  --c88d-btn-color: var(--primary);
  --c88d-btn-bg: var(--background2);
  --c88d-border-radius: 4px;
  --c88d-bar-position: translateX(50%);
}
</style>

<style scoped lang="scss">
:deep(.c88d-btn::before),
:deep(.c88d-btn::after),
:deep(.c88d-btn *::before),
:deep(.c88d-btn *::after) {
  --c88d-btn-width: var(--c88d-btn-width: );
  --c88d-btn-color: var(--c88d-btn-color);
  --c88d-btn-bg: var(--c88d-btn-bg);
  --c88d-border-radius: var(--c88d-border-radius);
  --c88d-bar-position: var(--c88d-bar-position);
}
.c88d-btn {
  aspect-ratio: 2.55;
  max-width: var(--c88d-btn-width);
  width: 100%;
  background-color: var(--c88d-btn-bg);
  border-radius: var(--c88d-border-radius);
  position: relative;
  display: flex;
  align-items: center;
  color: white;
  transition: all 0.4s;
}

.c88d-btn::after {
  content: "";
  position: absolute;
  top: 0;
  left: 0;
  width: 100%;
  height: 100%;
  background-color: var(--c88d-btn-bg);
  border-radius: var(--c88d-border-radius);
  opacity: 0.3;
  transition: opacity 0.4s;
}

.c88d-btn:hover,
.c88d-btn:focus,
.c88d-btn.active {
  transform: translateY(-10%);
}
.c88d-btn:hover::after,
.c88d-btn:focus::after,
.c88d-btn.active::after {
  opacity: 0;
}

.c88d-btn__container {
  width: 100%;
  height: 100%;
  position: relative;
  display: flex;
  align-items: center;
  justify-content: center;
  overflow: hidden;
}

.c88d-btn__logo {
  max-height: 50%;
  height: 100%;
}
.c88d-btn.active .c88d-btn__logo,
.c88d-btn:hover .c88d-btn__logo,
.c88d-btn:active .c88d-btn__logo {
  filter: var(--primary-filter);
}
.c88d-btn__bottom {
  position: absolute;
  width: 100%;
  height: 11%;
  left: 0;
  bottom: 0;
  overflow: hidden;
}

.c88d-btn__bottom-bar {
  width: 100%;
  height: 100%;
  position: relative;
}

.c88d-btn__bottom-bar::before {
  content: "";
  position: absolute;
  bottom: 0;
  left: 0;
  width: 100%;
  height: 50%;
  background-color: var(--c88d-btn-color);
  border-bottom-left-radius: var(--c88d-border-radius);
  border-bottom-right-radius: var(--c88d-border-radius);
}

.c88d-btn__bottom-bar::after {
  content: "";
  position: absolute;
  bottom: 42%;
  left: 0;
  width: 50%;
  height: 50%;
  transform: var(--c88d-bar-position);
  background-color: var(--c88d-btn-color);
  border-top-left-radius: var(--c88d-border-radius);
  border-top-right-radius: var(--c88d-border-radius);
}
.c88d-btn__tag-container {
  position: absolute;
  width: 100%;
  height: 100%;
  top: 0;
  right: 0;
  border-radius: var(--c88d-border-radius);
}
.c88d-btn__tags {
  position: relative;
  width: 100%;
  height: 100%;
  border-radius: var(--c88d-border-radius);
  overflow: hidden;
}
.c88d-btn__tag {
  position: absolute;
  width: 50px;
  height: 50px;
  top: -25px;
  right: -25px;
  display: flex;
  align-items: flex-end;
  justify-content: center;
  background-color: var(--c88d-btn-color);
  font-weight: 500;
  font-size: 10px;
  line-height: 12px;
  text-align: center;
  text-transform: uppercase;
  color: var(--textBtn);
  transform: rotate(45deg);
}
[theme-color="bk8"] .c88d-btn__text,
[theme-color="bk8_blue"] .c88d-btn__text {
  font-weight: 500;
  font-size: 14px;
  line-height: 12px;
  text-align: start;
  text-transform: uppercase;
  color: var(--text2);
  display: inline-block;
  width: 100%;
  // animation: floatText 10s infinite linear;
  // padding-left: 100%; /*Initial offset*/
  // overflow: hidden;
  padding: 0 1rem;
}
.c88d-btn__text:hover {
  animation-play-state: paused;
}
@keyframes floatText {
  to {
    transform: translateX(-100%);
  }
}
.c88d-btn:hover .c88d-btn__text,
.c88d-btn:focus .c88d-btn__text,
.c88d-btn.active .c88d-btn__text {
  color: var(--c88d-btn-color);
}
.c88d-btn__container[with-text="true"] {
  flex-direction: column;
}
</style>
